#ifndef JET_H
#define JET_H

enum jet_e {
	JET_IDLE = 0,
	JET_FIDGET,
	JET_PINPULL,
	JET_THROW1,	// toss
	JET_THROW2,	// medium
	JET_THROW3,	// hard
	JET_HOLSTER,
	JET_DRAW
};

class CJet : public CBasePlayerWeapon
{
public:
	void EXPORT findetour( void );
	virtual void PrimaryAttack( void )
	{	if (m_pPlayer->m_iClientarme)
return;
	 if (!m_pPlayer->m_iClienttire)
	 return;
	 
	if (m_pPlayer->m_iClientkami )
		return;
		if (m_pPlayer->m_iClientFindetour)
	{if (!m_flStartThrow && m_pPlayer->m_rgAmmo[m_iPrimaryAmmoType] > 0)
			{	m_pPlayer->m_iClientkami =1;
				m_flStartThrow = gpGlobals->time;
				m_flReleaseThrow = 0;
				SendWeaponAnim( JET_PINPULL );
				m_flTimeWeaponIdle = gpGlobals->time + 0.5;
			}
	}}
	virtual void SecondaryAttack( void )
		{
			time ++;
			if (time > 5)
				time = 1;
			ClientPrint(m_pPlayer->pev, HUD_PRINTCENTER, UTIL_VarArgs("Reglage: %d secondes\n", (int) time ));
			m_flNextSecondaryAttack = gpGlobals->time + 0.2;
		}
	virtual void Action ( Vector vec1, Vector vec2 )
		{
			return;
		}
	virtual BOOL Deploy( void ) {return TRUE;}
	virtual BOOL CanHolster( void )
		{
			return ( m_flStartThrow == 0 );
		}
	virtual void Holster( int skiplocal = 0 ) {return;}
	virtual void WeaponIdle( void )
{
	if (m_flReleaseThrow == 0)
		m_flReleaseThrow = gpGlobals->time;



	if (m_flTimeWeaponIdle > gpGlobals->time)
		return;

	if (m_flStartThrow)
	{
		Vector angThrow = m_pPlayer->pev->v_angle + m_pPlayer->pev->punchangle;

		if (angThrow.x < 0)
			angThrow.x = -10 + angThrow.x * ((90 - 10) / 90.0);
		else
			angThrow.x = -10 + angThrow.x * ((90 + 10) / 90.0);

// WHL++
		float flVel = 2500 * ((gpGlobals->time - m_flStartThrow) / 5.0 ) - 200;
		if (flVel > 2000)
			flVel = 2000;
// WHL--
		UTIL_MakeVectors( angThrow );

		Vector vecSrc = m_pPlayer->pev->origin + m_pPlayer->pev->view_ofs + gpGlobals->v_forward * 16;

		Vector vecThrow = gpGlobals->v_forward * flVel + m_pPlayer->pev->velocity;

		// alway explode 3 seconds after the pin was pulled
	if (!m_pPlayer->m_iClientkami )//arf
	{m_flStartThrow=0;
		m_flReleaseThrow = 0;
		m_pPlayer->m_rgAmmo[m_iPrimaryAmmoType]--;
		return;}

		Action( vecSrc, vecThrow ); // ca servira ensuite. patience...


		if (flVel < 500)
		{
			SendWeaponAnim( JET_THROW1 );
		}
		else if (flVel < 15000)
		{
			SendWeaponAnim( JET_THROW2 );
		}
		else
		{
			SendWeaponAnim( JET_THROW3 );
		}

		// player "shoot" animation
		m_pPlayer->SetAnimation( PLAYER_ATTACK1 );

		m_flStartThrow = 0;
		m_flNextPrimaryAttack = gpGlobals->time + 0.5;
		m_flTimeWeaponIdle = gpGlobals->time + 0.5;
m_pPlayer->m_iClientkami =0;
		m_pPlayer->m_rgAmmo[m_iPrimaryAmmoType]--;
        	SetThink(findetour);
       pev->nextthink = gpGlobals->time + 2.0;
	    m_pPlayer->m_iClienttire =0;
	
		if ( !m_pPlayer->m_rgAmmo[m_iPrimaryAmmoType] )
		{
			// just threw last grenade
			// set attack times in the future, and weapon idle in the future so we can see the whole throw
			// animation, weapon idle will automatically retire the weapon for us.
			m_flTimeWeaponIdle = m_flNextSecondaryAttack = m_flNextPrimaryAttack = gpGlobals->time + 0.5;// ensure that the animation can finish playing
		}
		return;
	}
	else if (m_flReleaseThrow > 0)
	{
		// we've finished the throw, restart.
		m_flStartThrow = 0;

		if (m_pPlayer->m_rgAmmo[m_iPrimaryAmmoType])
		{
			SendWeaponAnim( JET_DRAW );
		}
		else
		{
			RetireWeapon();
			return;
		}

		m_flTimeWeaponIdle = gpGlobals->time + RANDOM_FLOAT ( 10, 15 );
		m_flReleaseThrow = -1;
		return;
	}

	if (m_pPlayer->m_rgAmmo[m_iPrimaryAmmoType])
	{
		int iAnim;
		float flRand = RANDOM_FLOAT(0, 1);
		if (flRand <= 0.75)
		{
			iAnim = JET_IDLE;
			m_flTimeWeaponIdle = gpGlobals->time + RANDOM_FLOAT ( 10, 15 );// how long till we do this again.
		}
		else 
		{
			iAnim = JET_FIDGET;
			m_flTimeWeaponIdle = gpGlobals->time + 75.0 / 30.0;
		}

		SendWeaponAnim( iAnim );
	}
}
	float m_flStartThrow;	// debut du lancer
	float m_flReleaseThrow;	// ?
	float time;	// temps avant boom
	
};
#endif
