#include "hud.h"
#include "cl_util.h"
#include "parsemsg.h"
#include <stdio.h>
#include <string.h>

extern int bluematch,redmatch;


DECLARE_MESSAGE( m_Score, Score );


int CHudScore :: Init( void )
{
HOOK_MESSAGE( Score );
m_iFlags |= HUD_ACTIVE;
gHUD.AddHudElem( this );

return 1;
}

int CHudScore :: MsgFunc_Score( const char *pszName, int iSize, void *pbuf )
{

BEGIN_READ( pbuf, iSize );
Redscore=READ_BYTE();
Bluescore=READ_BYTE();


return 1;
}


int CHudScore :: Draw( float flTime )
{

if(redmatch==NULL)redmatch=0;
if(bluematch==NULL)bluematch=0;

int x=ScreenWidth-3*gHUD.m_iFontHeight;
int y=ScreenHeight-4.5*gHUD.m_iFontHeight;

//set
if(Redscore<10)gHUD.DrawHudNumber( x, y, DHN_DRAWZERO , Redscore, 255, 0, 0 );
else gHUD.DrawHudNumber( x-0.6*gHUD.m_iFontHeight, y, DHN_DRAWZERO | DHN_2DIGITS , Redscore, 255, 0, 0 );
if(Bluescore<10)gHUD.DrawHudNumber( x, y+1.25*gHUD.m_iFontHeight, DHN_DRAWZERO, Bluescore, 0, 0, 255 );
else gHUD.DrawHudNumber( x-0.6*gHUD.m_iFontHeight, y+1.25*gHUD.m_iFontHeight, DHN_DRAWZERO | DHN_2DIGITS, Bluescore, 0, 0, 255 );

// |
x=x+1.4*gHUD.m_iFontHeight;
FillRGBA(x, y, 2, 2.25*gHUD.m_iFontHeight, 255, 255, 255, 255);

//match
gHUD.DrawHudNumber( x+0.4*gHUD.m_iFontHeight, y, DHN_DRAWZERO  , redmatch, 255, 0, 0 );
gHUD.DrawHudNumber( x+0.4*gHUD.m_iFontHeight, y+1.25*gHUD.m_iFontHeight, DHN_DRAWZERO , bluematch, 0, 0, 255 );

return 1;

}