/*Code pour afficher un sol de feu pour le mod WORMSHL
/cod par The Dude
/09/05/01
/*/

#ifndef FIREFLOOR_H

#include "effects.h"
#define FIREFLOOR_H

#define FIRE_SPRITE "sprites/fire.spr"

class CBasePlayer;

class CFireFloor : public CBaseEntity
{
	public:
	virtual void Spawn( void );
	virtual void Precache ( void );
	virtual void EXPORT MyTouch( CBaseEntity* );
	virtual void EXPORT tj();

	static CFireFloor *CreateFireFloor( Vector vecOrigin, Vector vecAngles);

private :
	//CBeam    *m_pBeam;
	//CBeam    *m_pNoise;
	CSprite    *m_pSprite;
	CBasePlayerWeapon *m_pLauncher;
	float		DeathTimer;

};

#endif 
