#include "extdll.h" 
#include "decals.h" 
#include "util.h" 
#include "cbase.h" 
#include "monsters.h" 
#include "weapons.h" 
#include "nodes.h" 
#include "player.h" 
#include "soundent.h" 
#include "shake.h" 
#include "gamerules.h" 
#include "effects.h"
#include "const.h"
#include "customentity.h"
#include "func_break.h"
#include "shake.h"

#define FIRE_SPRITE "sprites/fire.spr"

class CObjectTouch : public CBaseEntity 
{ 
public: 

void Spawn( ); 
void Precache( ); 
void EXPORT MyTouch( CBaseEntity* ); 
void EXPORT tj();
private :
		CBeam				*m_pBeam;
	CBeam				*m_pNoise;
	CSprite				*m_pSprite;

}; 

LINK_ENTITY_TO_CLASS( flamme_touch, CObjectTouch ); 

void CObjectTouch :: Spawn( ) 
{
UTIL_SetOrigin( pev, pev->origin ); 
UTIL_SetSize( pev, Vector(-16,-16,0), Vector
(16,16,64) ); 

pev->movetype = MOVETYPE_BOUNCE; 
pev->solid = SOLID_NOT; 

SetThink(tj);
pev->nextthink = gpGlobals->time + 0.1;

	m_pSprite = CSprite::SpriteCreate( FIRE_SPRITE, pev->origin, TRUE );
	m_pSprite->pev->scale = 1.0;
	m_pSprite->SetTransparency( kRenderGlow, 255, 255, 255, 255, kRenderFxNoDissipation );
	m_pSprite->pev->spawnflags |= SF_SPRITE_TEMPORARY	;
       


} 

void CObjectTouch :: Precache( ) 
{ PRECACHE_MODEL( FIRE_SPRITE );

} 

void CObjectTouch :: MyTouch( CBaseEntity* Player =NULL) 
{ 
}

void CObjectTouch :: tj( ) 
{
 SetThink(tj);
pev->nextthink = gpGlobals->time + 0.1;

      
m_pSprite->pev->frame = ((int)m_pSprite->pev->frame + 1) % 15;


CBaseEntity *pEntity = NULL;
while ((pEntity = UTIL_FindEntityInSphere( pEntity, pev->origin, 20 )) != NULL) 
{
if (FClassnameIs( pEntity->pev, "player"))
{
pEntity->pev->health -=2;}
}
}

	


	